diff --git a/ChangeLog b/ChangeLog
index c908015b..80c73b79 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+10/19/2022
+- fix cleanup of semaphores; see #522, closes #458
+  simplify mutex/shm cleanup without semaphores because we track the parent process anyway; 
+- bump to 2.4.12.1rc0
+
 10/17/2022
 - release 2.4.12
 
diff --git a/configure.ac b/configure.ac
index 1e67d863..359ed22d 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,4 +1,4 @@
-AC_INIT([mod_auth_openidc],[2.4.12],[hans.zandbelt@zmartzone.eu])
+AC_INIT([mod_auth_openidc],[2.4.12.1rc0],[hans.zandbelt@zmartzone.eu])
 
 AC_SUBST(NAMEVER, AC_PACKAGE_TARNAME()-AC_PACKAGE_VERSION())
 
diff --git a/src/cache/cache.h b/src/cache/cache.h
index 7da78b12..0f41a6a8 100644
--- a/src/cache/cache.h
+++ b/src/cache/cache.h
@@ -72,8 +72,6 @@ typedef struct oidc_cache_t {
 typedef struct oidc_cache_mutex_t {
 	apr_global_mutex_t *mutex;
 	char *mutex_filename;
-	apr_shm_t *shm;
-	int *sema;
 	apr_byte_t is_parent;
 } oidc_cache_mutex_t;
 
diff --git a/src/cache/common.c b/src/cache/common.c
index f27c4081..ac970791 100644
--- a/src/cache/common.c
+++ b/src/cache/common.c
@@ -60,8 +60,6 @@ oidc_cache_mutex_t *oidc_cache_mutex_create(apr_pool_t *pool) {
 	oidc_cache_mutex_t *ctx = apr_pcalloc(pool, sizeof(oidc_cache_mutex_t));
 	ctx->mutex = NULL;
 	ctx->mutex_filename = NULL;
-	ctx->shm = NULL;
-	ctx->sema = NULL;
 	ctx->is_parent = TRUE;
 	return ctx;
 }
@@ -82,8 +80,6 @@ apr_byte_t oidc_cache_mutex_post_config(server_rec *s, oidc_cache_mutex_t *m,
 	apr_status_t rv = APR_SUCCESS;
 	const char *dir;
 
-	// oidc_sdebug(s, "enter: %d (m=%pp,s=%pp, p=%d)", (m && m->sema) ? *m->sema : -1, m->mutex ? m->mutex : 0, s, m->is_parent);
-
 	/* construct the mutex filename */
 	apr_temp_dir_get(&dir, s->process->pool);
 	m->mutex_filename = apr_psprintf(s->process->pool,
@@ -115,18 +111,7 @@ apr_byte_t oidc_cache_mutex_post_config(server_rec *s, oidc_cache_mutex_t *m,
 	}
 #endif
 
-	apr_global_mutex_lock(m->mutex);
-
-	rv = apr_shm_create(&m->shm, sizeof(int), NULL, s->process->pool);
-	if (rv != APR_SUCCESS) {
-		oidc_serror(s, "apr_shm_create failed to create shared memory segment");
-		return FALSE;
-	}
-
-	m->sema = apr_shm_baseaddr_get(m->shm);
-	*m->sema = 1;
-
-	apr_global_mutex_unlock(m->mutex);
+	oidc_slog(s, APLOG_TRACE1, "create: %pp (m=%pp,s=%pp, p=%d)", m, m->mutex ? m->mutex : 0, s, m->is_parent);
 
 	return TRUE;
 }
@@ -137,7 +122,7 @@ apr_byte_t oidc_cache_mutex_post_config(server_rec *s, oidc_cache_mutex_t *m,
 apr_status_t oidc_cache_mutex_child_init(apr_pool_t *p, server_rec *s,
 		oidc_cache_mutex_t *m) {
 
-	// oidc_sdebug(s, "enter: %d (m=%pp,s=%pp, p=%d)", (m && m->sema) ? *m->sema : -1, m->mutex ? m->mutex : 0, s, m->is_parent);
+	oidc_slog(s, APLOG_TRACE1, "init: %pp (m=%pp,s=%pp, p=%d)", m, m->mutex ? m->mutex : 0, s, m->is_parent);
 
 	if (m->is_parent == FALSE)
 		return APR_SUCCESS;
@@ -150,15 +135,9 @@ apr_status_t oidc_cache_mutex_child_init(apr_pool_t *p, server_rec *s,
 		oidc_serror(s,
 				"apr_global_mutex_child_init failed to reopen mutex on file %s: %s (%d)",
 				m->mutex_filename, oidc_cache_status2str(rv), rv);
-	} else {
-		apr_global_mutex_lock(m->mutex);
-		m->sema = apr_shm_baseaddr_get(m->shm);
-		(*m->sema)++;
-		apr_global_mutex_unlock(m->mutex);
 	}
 
 	m->is_parent = FALSE;
-	//oidc_sdebug(s, "semaphore: %d (m=%pp,s=%pp)", *m->sema, m, s);
 
 	return rv;
 }
@@ -198,35 +177,12 @@ apr_byte_t oidc_cache_mutex_destroy(server_rec *s, oidc_cache_mutex_t *m) {
 
 	apr_status_t rv = APR_SUCCESS;
 
-	// oidc_sdebug(s, "enter: %d (m=%pp,s=%pp, p=%d)", (m && m->sema) ? *m->sema : -1, m->mutex ? m->mutex : 0, s, m->is_parent);
-
-	if (m->mutex != NULL) {
-
-		apr_global_mutex_lock(m->mutex);
-		(*m->sema)--;
-		//oidc_sdebug(s, "semaphore: %d (m=%pp,s=%pp)", *m->sema, m->mutex, s);
+	oidc_slog(s, APLOG_TRACE1, "init: %pp (m=%pp,s=%pp, p=%d)", m, m->mutex ? m->mutex : 0, s, m->is_parent);
 
-		// oidc_sdebug(s, "processing: %d (m=%pp,s=%pp, p=%d)", (m && m->sema) ? *m->sema : -1, m->mutex ? m->mutex : 0, s, m->is_parent);
-
-		if ((m->shm != NULL) && (*m->sema == 0) && (m->is_parent == TRUE)) {
-
-			rv = apr_shm_destroy(m->shm);
-			oidc_sdebug(s, "apr_shm_destroy for semaphore returned: %d", rv);
-			m->shm = NULL;
-
-			apr_global_mutex_unlock(m->mutex);
-
-			rv = apr_global_mutex_destroy(m->mutex);
-			oidc_sdebug(s, "apr_global_mutex_destroy returned :%d", rv);
-			m->mutex = NULL;
-
-			rv = APR_SUCCESS;
-
-		} else {
-
-			apr_global_mutex_unlock(m->mutex);
-
-		}
+	if ((m) && (m->is_parent == TRUE) && (m->mutex)) {
+		rv = apr_global_mutex_destroy(m->mutex);
+		oidc_sdebug(s, "apr_global_mutex_destroy returned :%d", rv);
+		m->mutex = NULL;
 	}
 
 	return rv;
diff --git a/src/cache/shm.c b/src/cache/shm.c
index cf4fcd53..8ae076ab 100644
--- a/src/cache/shm.c
+++ b/src/cache/shm.c
@@ -119,6 +119,8 @@ int oidc_cache_shm_post_config(server_rec *s) {
 			"initialized shared memory with a cache size (# entries) of: %d, and a max (single) entry size of: %d",
 			cfg->cache_shm_size_max, cfg->cache_shm_entry_size_max);
 
+	oidc_slog(s, APLOG_TRACE1, "create: %pp (shm=%pp,s=%pp, p=%d)", context, context ? context->shm : 0, s, context ? context->is_parent : -1);
+
 	return OK;
 }
 
@@ -130,6 +132,10 @@ int oidc_cache_shm_child_init(apr_pool_t *p, server_rec *s) {
 			&auth_openidc_module);
 	oidc_cache_cfg_shm_t *context = (oidc_cache_cfg_shm_t *) cfg->cache_cfg;
 
+	oidc_slog(s, APLOG_TRACE1, "init: %pp (shm=%pp,s=%pp, p=%d)", context, context ? context->shm : 0, s, context ? context->is_parent : -1);
+
+	if (context->is_parent == FALSE)
+		return APR_SUCCESS;
 	context->is_parent = FALSE;
 
 	/* initialize the lock for the child process */
@@ -330,24 +336,20 @@ static int oidc_cache_shm_destroy(server_rec *s) {
 	oidc_cache_cfg_shm_t *context = (oidc_cache_cfg_shm_t *) cfg->cache_cfg;
 	apr_status_t rv = APR_SUCCESS;
 
-	if (context == NULL)
-		return rv;
+	oidc_slog(s, APLOG_TRACE1, "destroy: %pp (shm=%pp,s=%pp, p=%d)", context, context ? context->shm : 0, s, context ? context->is_parent : -1);
 
-	if ((context->is_parent == TRUE) && (context->shm)) {
+	if ((context) && (context->is_parent == TRUE) && (context->shm) && (context->mutex)) {
 		oidc_cache_mutex_lock(s, context->mutex);
-		if (*context->mutex->sema == 1) {
-			rv = apr_shm_destroy(context->shm);
-			oidc_sdebug(s, "apr_shm_destroy returned: %d", rv);
-		}
+		rv = apr_shm_destroy(context->shm);
+		oidc_sdebug(s, "apr_shm_destroy returned: %d", rv);
 		context->shm = NULL;
 		oidc_cache_mutex_unlock(s, context->mutex);
 	}
 
-	if (context->mutex == NULL)
-		return rv;
-
-	oidc_cache_mutex_destroy(s, context->mutex);
-	context->mutex = NULL;
+	if ((context) && (context->mutex)) {
+		rv = oidc_cache_mutex_destroy(s, context->mutex);
+		context->mutex = NULL;
+	}
 
 	return rv;
 }
diff --git a/test/openidc.conf b/test/openidc.conf
index 6575146d..ac9f7805 100644
--- a/test/openidc.conf
+++ b/test/openidc.conf
@@ -1,5 +1,5 @@
 
-LogLevel auth_openidc:debug
+LogLevel auth_openidc:trace1
 
 LoadModule auth_openidc_module /usr/lib/apache2/modules/mod_auth_openidc.so
 OIDCProviderMetadataURL https://keycloak:8443/auth/realms/master/.well-known/openid-configuration
diff --git a/test/valgrind.sh b/test/valgrind.sh
index 34e1e0d8..cbe67664 100755
--- a/test/valgrind.sh
+++ b/test/valgrind.sh
@@ -12,13 +12,14 @@ source /etc/apache2/envvars
 
 valgrind \
 	--leak-check=full \
+	--trace-children=yes \
 	--error-exitcode=1 \
 	--show-possibly-lost=no \
 	--read-inline-info=yes \
 	--keep-debuginfo=yes \
 	--undef-value-errors=no \
 	--log-file=/tmp/valgrind.log \
-	/usr/sbin/apache2 -X &
+	/usr/sbin/apache2 -DFOREGROUND &
 
 child=$! 
 wait "$child"
